=begin
#Wire4RestAPI

#Referencia de la API de Wire4

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.10

=end

require 'uri'

module Wire4Client
  class AutorizacinDeDepsitosApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Consulta autorización de depósitos
    # Obtiene la información de la autorización de depósitos del contrato relacionado a la suscripción.
    # @param authorization Header para token
    # @param subscription Es el identificador de la suscripción a esta API.
    # @param [Hash] opts the optional parameters
    # @return [DepositsAuthorizationResponse]
    def get_deposit_auth_configurations(authorization, subscription, opts = {})
      data, _status_code, _headers = get_deposit_auth_configurations_with_http_info(authorization, subscription, opts)
      data
    end

    # Consulta autorización de depósitos
    # Obtiene la información de la autorización de depósitos del contrato relacionado a la suscripción.
    # @param authorization Header para token
    # @param subscription Es el identificador de la suscripción a esta API.
    # @param [Hash] opts the optional parameters
    # @return [Array<(DepositsAuthorizationResponse, Fixnum, Hash)>] DepositsAuthorizationResponse data, response status code and response headers
    def get_deposit_auth_configurations_with_http_info(authorization, subscription, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AutorizacinDeDepsitosApi.get_deposit_auth_configurations ...'
      end
      # verify the required parameter 'authorization' is set
      if @api_client.config.client_side_validation && authorization.nil?
        fail ArgumentError, "Missing the required parameter 'authorization' when calling AutorizacinDeDepsitosApi.get_deposit_auth_configurations"
      end
      # verify the required parameter 'subscription' is set
      if @api_client.config.client_side_validation && subscription.nil?
        fail ArgumentError, "Missing the required parameter 'subscription' when calling AutorizacinDeDepsitosApi.get_deposit_auth_configurations"
      end
      if @api_client.config.client_side_validation && subscription.to_s.length > 36
        fail ArgumentError, 'invalid value for "subscription" when calling AutorizacinDeDepsitosApi.get_deposit_auth_configurations, the character length must be smaller than or equal to 36.'
      end

      if @api_client.config.client_side_validation && subscription.to_s.length < 36
        fail ArgumentError, 'invalid value for "subscription" when calling AutorizacinDeDepsitosApi.get_deposit_auth_configurations, the character length must be great than or equal to 36.'
      end

      if @api_client.config.client_side_validation && subscription !~ Regexp.new(/[A-Fa-f0-9]{8}-[A-Fa-f0-9]{4}-[34][A-Fa-f0-9]{3}-[89ab][A-Fa-f0-9]{3}-[A-Fa-f0-9]{12}$/)
        fail ArgumentError, "invalid value for 'subscription' when calling AutorizacinDeDepsitosApi.get_deposit_auth_configurations, must conform to the pattern /[A-Fa-f0-9]{8}-[A-Fa-f0-9]{4}-[34][A-Fa-f0-9]{3}-[89ab][A-Fa-f0-9]{3}-[A-Fa-f0-9]{12}$/."
      end

      # resource path
      local_var_path = '/subscriptions/{subscription}/configurations/deposit-authorization'.sub('{' + 'subscription' + '}', subscription.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'Authorization'] = authorization

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'DepositsAuthorizationResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AutorizacinDeDepsitosApi#get_deposit_auth_configurations\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Habilita / Deshabilita la autorización de depósitos
    # Habilita o deshabilita la autorización de depósitos. Devuelve la información final de la autorización de depósitos del contrato relacionado a la suscripción al terminar.
    # @param authorization Header para token
    # @param register Información para habilitar / deshabilitar la autorización de depósito
    # @param subscription Es el identificador de la suscripción a esta API.
    # @param [Hash] opts the optional parameters
    # @return [DepositsAuthorizationResponse]
    def put_deposit_auth_configurations(authorization, register, subscription, opts = {})
      data, _status_code, _headers = put_deposit_auth_configurations_with_http_info(authorization, register, subscription, opts)
      data
    end

    # Habilita / Deshabilita la autorización de depósitos
    # Habilita o deshabilita la autorización de depósitos. Devuelve la información final de la autorización de depósitos del contrato relacionado a la suscripción al terminar.
    # @param authorization Header para token
    # @param register Información para habilitar / deshabilitar la autorización de depósito
    # @param subscription Es el identificador de la suscripción a esta API.
    # @param [Hash] opts the optional parameters
    # @return [Array<(DepositsAuthorizationResponse, Fixnum, Hash)>] DepositsAuthorizationResponse data, response status code and response headers
    def put_deposit_auth_configurations_with_http_info(authorization, register, subscription, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AutorizacinDeDepsitosApi.put_deposit_auth_configurations ...'
      end
      # verify the required parameter 'authorization' is set
      if @api_client.config.client_side_validation && authorization.nil?
        fail ArgumentError, "Missing the required parameter 'authorization' when calling AutorizacinDeDepsitosApi.put_deposit_auth_configurations"
      end
      # verify the required parameter 'register' is set
      if @api_client.config.client_side_validation && register.nil?
        fail ArgumentError, "Missing the required parameter 'register' when calling AutorizacinDeDepsitosApi.put_deposit_auth_configurations"
      end
      # verify the required parameter 'subscription' is set
      if @api_client.config.client_side_validation && subscription.nil?
        fail ArgumentError, "Missing the required parameter 'subscription' when calling AutorizacinDeDepsitosApi.put_deposit_auth_configurations"
      end
      if @api_client.config.client_side_validation && subscription.to_s.length > 36
        fail ArgumentError, 'invalid value for "subscription" when calling AutorizacinDeDepsitosApi.put_deposit_auth_configurations, the character length must be smaller than or equal to 36.'
      end

      if @api_client.config.client_side_validation && subscription.to_s.length < 36
        fail ArgumentError, 'invalid value for "subscription" when calling AutorizacinDeDepsitosApi.put_deposit_auth_configurations, the character length must be great than or equal to 36.'
      end

      if @api_client.config.client_side_validation && subscription !~ Regexp.new(/[A-Fa-f0-9]{8}-[A-Fa-f0-9]{4}-[34][A-Fa-f0-9]{3}-[89ab][A-Fa-f0-9]{3}-[A-Fa-f0-9]{12}$/)
        fail ArgumentError, "invalid value for 'subscription' when calling AutorizacinDeDepsitosApi.put_deposit_auth_configurations, must conform to the pattern /[A-Fa-f0-9]{8}-[A-Fa-f0-9]{4}-[34][A-Fa-f0-9]{3}-[89ab][A-Fa-f0-9]{3}-[A-Fa-f0-9]{12}$/."
      end

      # resource path
      local_var_path = '/subscriptions/{subscription}/configurations/deposit-authorization'.sub('{' + 'subscription' + '}', subscription.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'Authorization'] = authorization

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(register)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'DepositsAuthorizationResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AutorizacinDeDepsitosApi#put_deposit_auth_configurations\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
