=begin
#Wire4RestAPI

#Referencia de la API de Wire4

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.10

=end

require 'uri'

module Wire4Client
  class InstitucionesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Consulta de instituciones bancarias
    # Se obtiene un listado de las instituciones bancarias y la información de cada una de estas.
    # @param authorization Header para token
    # @param [Hash] opts the optional parameters
    # @return [InstitutionsList]
    def get_all_institutions_using_get(authorization, opts = {})
      data, _status_code, _headers = get_all_institutions_using_get_with_http_info(authorization, opts)
      data
    end

    # Consulta de instituciones bancarias
    # Se obtiene un listado de las instituciones bancarias y la información de cada una de estas.
    # @param authorization Header para token
    # @param [Hash] opts the optional parameters
    # @return [Array<(InstitutionsList, Fixnum, Hash)>] InstitutionsList data, response status code and response headers
    def get_all_institutions_using_get_with_http_info(authorization, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: InstitucionesApi.get_all_institutions_using_get ...'
      end
      # verify the required parameter 'authorization' is set
      if @api_client.config.client_side_validation && authorization.nil?
        fail ArgumentError, "Missing the required parameter 'authorization' when calling InstitucionesApi.get_all_institutions_using_get"
      end
      # resource path
      local_var_path = '/institutions'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'Authorization'] = authorization

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InstitutionsList')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: InstitucionesApi#get_all_institutions_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
