=begin
#Wire4RestAPI

#Referencia de la API de Wire4

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.10

=end

require 'uri'

module Wire4Client
  class LmitesDeMontosApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Consulta de configuraciones
    # Consulta las configuraciones para el contrato asocaido al enrolamiento en la aplicación.
    # @param authorization Header para token
    # @param suscription Es el identificador de la suscripción a esta API.
    # @param [Hash] opts the optional parameters
    # @return [MessageConfigurationsLimits]
    def obtain_configurations_limits(authorization, suscription, opts = {})
      data, _status_code, _headers = obtain_configurations_limits_with_http_info(authorization, suscription, opts)
      data
    end

    # Consulta de configuraciones
    # Consulta las configuraciones para el contrato asocaido al enrolamiento en la aplicación.
    # @param authorization Header para token
    # @param suscription Es el identificador de la suscripción a esta API.
    # @param [Hash] opts the optional parameters
    # @return [Array<(MessageConfigurationsLimits, Fixnum, Hash)>] MessageConfigurationsLimits data, response status code and response headers
    def obtain_configurations_limits_with_http_info(authorization, suscription, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: LmitesDeMontosApi.obtain_configurations_limits ...'
      end
      # verify the required parameter 'authorization' is set
      if @api_client.config.client_side_validation && authorization.nil?
        fail ArgumentError, "Missing the required parameter 'authorization' when calling LmitesDeMontosApi.obtain_configurations_limits"
      end
      # verify the required parameter 'suscription' is set
      if @api_client.config.client_side_validation && suscription.nil?
        fail ArgumentError, "Missing the required parameter 'suscription' when calling LmitesDeMontosApi.obtain_configurations_limits"
      end
      if @api_client.config.client_side_validation && suscription.to_s.length > 36
        fail ArgumentError, 'invalid value for "suscription" when calling LmitesDeMontosApi.obtain_configurations_limits, the character length must be smaller than or equal to 36.'
      end

      if @api_client.config.client_side_validation && suscription.to_s.length < 36
        fail ArgumentError, 'invalid value for "suscription" when calling LmitesDeMontosApi.obtain_configurations_limits, the character length must be great than or equal to 36.'
      end

      if @api_client.config.client_side_validation && suscription !~ Regexp.new(/[A-Fa-f0-9]{8}-[A-Fa-f0-9]{4}-[34][A-Fa-f0-9]{3}-[89ab][A-Fa-f0-9]{3}-[A-Fa-f0-9]{12}$/)
        fail ArgumentError, "invalid value for 'suscription' when calling LmitesDeMontosApi.obtain_configurations_limits, must conform to the pattern /[A-Fa-f0-9]{8}-[A-Fa-f0-9]{4}-[34][A-Fa-f0-9]{3}-[89ab][A-Fa-f0-9]{3}-[A-Fa-f0-9]{12}$/."
      end

      # resource path
      local_var_path = '/subscriptions/{suscription}/configurations'.sub('{' + 'suscription' + '}', suscription.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'Authorization'] = authorization

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'MessageConfigurationsLimits')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: LmitesDeMontosApi#obtain_configurations_limits\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Actualiza configuraciones por suscripción
    # Actualiza las configuraciones de un contrato asociado a una suscripción
    # @param authorization Header para token
    # @param suscription suscription
    # @param update_configurations_resquest_dto updateConfigurationsResquestDTO
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def update_configurations(authorization, suscription, update_configurations_resquest_dto, opts = {})
      update_configurations_with_http_info(authorization, suscription, update_configurations_resquest_dto, opts)
      nil
    end

    # Actualiza configuraciones por suscripción
    # Actualiza las configuraciones de un contrato asociado a una suscripción
    # @param authorization Header para token
    # @param suscription suscription
    # @param update_configurations_resquest_dto updateConfigurationsResquestDTO
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def update_configurations_with_http_info(authorization, suscription, update_configurations_resquest_dto, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: LmitesDeMontosApi.update_configurations ...'
      end
      # verify the required parameter 'authorization' is set
      if @api_client.config.client_side_validation && authorization.nil?
        fail ArgumentError, "Missing the required parameter 'authorization' when calling LmitesDeMontosApi.update_configurations"
      end
      # verify the required parameter 'suscription' is set
      if @api_client.config.client_side_validation && suscription.nil?
        fail ArgumentError, "Missing the required parameter 'suscription' when calling LmitesDeMontosApi.update_configurations"
      end
      # verify the required parameter 'update_configurations_resquest_dto' is set
      if @api_client.config.client_side_validation && update_configurations_resquest_dto.nil?
        fail ArgumentError, "Missing the required parameter 'update_configurations_resquest_dto' when calling LmitesDeMontosApi.update_configurations"
      end
      # resource path
      local_var_path = '/subscriptions/{suscription}/configurations'.sub('{' + 'suscription' + '}', suscription.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'Authorization'] = authorization

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(update_configurations_resquest_dto)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: LmitesDeMontosApi#update_configurations\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
