=begin
#Wire4RestAPI

#Referencia de la API de Wire4

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.10

=end

require 'uri'

module Wire4Client
  class PeticionesDePagoPorCoDiApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Consulta información de petición por orderId
    # Obtiene la información de una petición de pago CODI® por orderId para un punto de venta.
    # @param authorization Header para token
    # @param order_id Identificador del pago CODI®
    # @param sales_point_id Identificador del punto de venta
    # @param [Hash] opts the optional parameters
    # @return [PaymentRequestCodiResponseDTO]
    def consult_codi_request_by_order_id(authorization, order_id, sales_point_id, opts = {})
      data, _status_code, _headers = consult_codi_request_by_order_id_with_http_info(authorization, order_id, sales_point_id, opts)
      data
    end

    # Consulta información de petición por orderId
    # Obtiene la información de una petición de pago CODI® por orderId para un punto de venta.
    # @param authorization Header para token
    # @param order_id Identificador del pago CODI®
    # @param sales_point_id Identificador del punto de venta
    # @param [Hash] opts the optional parameters
    # @return [Array<(PaymentRequestCodiResponseDTO, Fixnum, Hash)>] PaymentRequestCodiResponseDTO data, response status code and response headers
    def consult_codi_request_by_order_id_with_http_info(authorization, order_id, sales_point_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PeticionesDePagoPorCoDiApi.consult_codi_request_by_order_id ...'
      end
      # verify the required parameter 'authorization' is set
      if @api_client.config.client_side_validation && authorization.nil?
        fail ArgumentError, "Missing the required parameter 'authorization' when calling PeticionesDePagoPorCoDiApi.consult_codi_request_by_order_id"
      end
      # verify the required parameter 'order_id' is set
      if @api_client.config.client_side_validation && order_id.nil?
        fail ArgumentError, "Missing the required parameter 'order_id' when calling PeticionesDePagoPorCoDiApi.consult_codi_request_by_order_id"
      end
      # verify the required parameter 'sales_point_id' is set
      if @api_client.config.client_side_validation && sales_point_id.nil?
        fail ArgumentError, "Missing the required parameter 'sales_point_id' when calling PeticionesDePagoPorCoDiApi.consult_codi_request_by_order_id"
      end
      if @api_client.config.client_side_validation && sales_point_id.to_s.length > 36
        fail ArgumentError, 'invalid value for "sales_point_id" when calling PeticionesDePagoPorCoDiApi.consult_codi_request_by_order_id, the character length must be smaller than or equal to 36.'
      end

      if @api_client.config.client_side_validation && sales_point_id.to_s.length < 36
        fail ArgumentError, 'invalid value for "sales_point_id" when calling PeticionesDePagoPorCoDiApi.consult_codi_request_by_order_id, the character length must be great than or equal to 36.'
      end

      # resource path
      local_var_path = '/codi/sales-point/charges'

      # query parameters
      query_params = {}
      query_params[:'orderId'] = order_id
      query_params[:'salesPointId'] = sales_point_id

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'Authorization'] = authorization

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PaymentRequestCodiResponseDTO')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PeticionesDePagoPorCoDiApi#consult_codi_request_by_order_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Genera código QR
    # Genera un código QR solicitado por un punto de venta para un pago mediante CODI®
    # @param authorization Header para token
    # @param codi_info Información del pago CODI®
    # @param sales_point_id Identificador del punto de venta
    # @param [Hash] opts the optional parameters
    # @return [CodiCodeQrResponseDTO]
    def generate_codi_code_qr(authorization, codi_info, sales_point_id, opts = {})
      data, _status_code, _headers = generate_codi_code_qr_with_http_info(authorization, codi_info, sales_point_id, opts)
      data
    end

    # Genera código QR
    # Genera un código QR solicitado por un punto de venta para un pago mediante CODI®
    # @param authorization Header para token
    # @param codi_info Información del pago CODI®
    # @param sales_point_id Identificador del punto de venta
    # @param [Hash] opts the optional parameters
    # @return [Array<(CodiCodeQrResponseDTO, Fixnum, Hash)>] CodiCodeQrResponseDTO data, response status code and response headers
    def generate_codi_code_qr_with_http_info(authorization, codi_info, sales_point_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PeticionesDePagoPorCoDiApi.generate_codi_code_qr ...'
      end
      # verify the required parameter 'authorization' is set
      if @api_client.config.client_side_validation && authorization.nil?
        fail ArgumentError, "Missing the required parameter 'authorization' when calling PeticionesDePagoPorCoDiApi.generate_codi_code_qr"
      end
      # verify the required parameter 'codi_info' is set
      if @api_client.config.client_side_validation && codi_info.nil?
        fail ArgumentError, "Missing the required parameter 'codi_info' when calling PeticionesDePagoPorCoDiApi.generate_codi_code_qr"
      end
      # verify the required parameter 'sales_point_id' is set
      if @api_client.config.client_side_validation && sales_point_id.nil?
        fail ArgumentError, "Missing the required parameter 'sales_point_id' when calling PeticionesDePagoPorCoDiApi.generate_codi_code_qr"
      end
      if @api_client.config.client_side_validation && sales_point_id.to_s.length > 36
        fail ArgumentError, 'invalid value for "sales_point_id" when calling PeticionesDePagoPorCoDiApi.generate_codi_code_qr, the character length must be smaller than or equal to 36.'
      end

      if @api_client.config.client_side_validation && sales_point_id.to_s.length < 36
        fail ArgumentError, 'invalid value for "sales_point_id" when calling PeticionesDePagoPorCoDiApi.generate_codi_code_qr, the character length must be great than or equal to 36.'
      end

      if @api_client.config.client_side_validation && sales_point_id !~ Regexp.new(/[A-Fa-f0-9]{8}-[A-Fa-f0-9]{4}-[34][A-Fa-f0-9]{3}-[89ab][A-Fa-f0-9]{3}-[A-Fa-f0-9]{12}$/)
        fail ArgumentError, "invalid value for 'sales_point_id' when calling PeticionesDePagoPorCoDiApi.generate_codi_code_qr, must conform to the pattern /[A-Fa-f0-9]{8}-[A-Fa-f0-9]{4}-[34][A-Fa-f0-9]{3}-[89ab][A-Fa-f0-9]{3}-[A-Fa-f0-9]{12}$/."
      end

      # resource path
      local_var_path = '/codi/sales-point/charges'

      # query parameters
      query_params = {}
      query_params[:'salesPointId'] = sales_point_id

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'Authorization'] = authorization

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(codi_info)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CodiCodeQrResponseDTO')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PeticionesDePagoPorCoDiApi#generate_codi_code_qr\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
