=begin
#Wire4RestAPI

#Referencia de la API de Wire4

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.10

=end

require 'date'

module Wire4Client
  # El usuario que corresponde al contrato
  class UserCompany
    # Una lista de los correos del usuario
    attr_accessor :emails

    # Indica sí es representate legal
    attr_accessor :legal_representative

    # El nombre del usuario enmascarado
    attr_accessor :masked_name

    # El nombre del usuario de acceso enmascarado
    attr_accessor :masked_user_name

    # El nombre del usuario
    attr_accessor :name

    # Una lista de los teléfonos del usuario
    attr_accessor :phone_numbers

    # El apellido paterno del usuario
    attr_accessor :surname_father

    # El apellido materno del usuario
    attr_accessor :surname_mother

    # El nombre del usuario de acceso
    attr_accessor :user_name

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'emails' => :'emails',
        :'legal_representative' => :'legal_representative',
        :'masked_name' => :'masked_name',
        :'masked_user_name' => :'masked_user_name',
        :'name' => :'name',
        :'phone_numbers' => :'phone_numbers',
        :'surname_father' => :'surname_father',
        :'surname_mother' => :'surname_mother',
        :'user_name' => :'user_name'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'emails' => :'Array<String>',
        :'legal_representative' => :'BOOLEAN',
        :'masked_name' => :'String',
        :'masked_user_name' => :'String',
        :'name' => :'String',
        :'phone_numbers' => :'Array<String>',
        :'surname_father' => :'String',
        :'surname_mother' => :'String',
        :'user_name' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'emails')
        if (value = attributes[:'emails']).is_a?(Array)
          self.emails = value
        end
      end

      if attributes.has_key?(:'legal_representative')
        self.legal_representative = attributes[:'legal_representative']
      end

      if attributes.has_key?(:'masked_name')
        self.masked_name = attributes[:'masked_name']
      end

      if attributes.has_key?(:'masked_user_name')
        self.masked_user_name = attributes[:'masked_user_name']
      end

      if attributes.has_key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.has_key?(:'phone_numbers')
        if (value = attributes[:'phone_numbers']).is_a?(Array)
          self.phone_numbers = value
        end
      end

      if attributes.has_key?(:'surname_father')
        self.surname_father = attributes[:'surname_father']
      end

      if attributes.has_key?(:'surname_mother')
        self.surname_mother = attributes[:'surname_mother']
      end

      if attributes.has_key?(:'user_name')
        self.user_name = attributes[:'user_name']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          emails == o.emails &&
          legal_representative == o.legal_representative &&
          masked_name == o.masked_name &&
          masked_user_name == o.masked_user_name &&
          name == o.name &&
          phone_numbers == o.phone_numbers &&
          surname_father == o.surname_father &&
          surname_mother == o.surname_mother &&
          user_name == o.user_name
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [emails, legal_representative, masked_name, masked_user_name, name, phone_numbers, surname_father, surname_mother, user_name].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = Wire4Client.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
